# bmlx-openapi-client
Documentation of bmlx api-server apis.
To find more info about generating spec from source, please refer to https://goswagger.io/use/spec.html

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import bmlx_openapi_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import bmlx_openapi_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function

import time
import bmlx_openapi_client
from bmlx_openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/api/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = bmlx_openapi_client.Configuration(
    host = "http://localhost/api/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure HTTP basic authorization: basicAuth
configuration = bmlx_openapi_client.Configuration(
    username = 'YOUR_USERNAME',
    password = 'YOUR_PASSWORD'
)


# Enter a context with an instance of the API client
with bmlx_openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = bmlx_openapi_client.ArtifactApi(api_client)
    artifact = bmlx_openapi_client.Artifact() # Artifact |  (optional)

    try:
        # CreateArtifact.
        api_response = api_instance.create_artifact(artifact=artifact)
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling ArtifactApi->create_artifact: %s\n" % e)
    
```

## Documentation for API Endpoints

All URIs are relative to *http://localhost/api/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ArtifactApi* | [**create_artifact**](docs/ArtifactApi.md#create_artifact) | **POST** /artifacts | CreateArtifact.
*ArtifactApi* | [**delete_artifact**](docs/ArtifactApi.md#delete_artifact) | **DELETE** /artifacts/{id} | DeleteArtifact by id.
*ArtifactApi* | [**get_artifact_by_id**](docs/ArtifactApi.md#get_artifact_by_id) | **GET** /artifacts/{id} | GetArtifact by id.
*ArtifactApi* | [**get_artifacts**](docs/ArtifactApi.md#get_artifacts) | **GET** /artifacts | GetArtifacts list.
*ArtifactApi* | [**update_artifact**](docs/ArtifactApi.md#update_artifact) | **PUT** /artifacts/{id} | UpdateArtifact by id.
*AuthApi* | [**authenticate**](docs/AuthApi.md#authenticate) | **GET** /authenticate | Authenticate by user and token request.
*ComponentRunApi* | [**create_component_run**](docs/ComponentRunApi.md#create_component_run) | **POST** /component_runs | CreateComponentRun.
*ComponentRunApi* | [**delete_component_run**](docs/ComponentRunApi.md#delete_component_run) | **DELETE** /component_runs/{id} | DeleteComponentRun by id.
*ComponentRunApi* | [**get_component_run_by_id**](docs/ComponentRunApi.md#get_component_run_by_id) | **GET** /component_runs/{id} | GetComponentRun by id.
*ComponentRunApi* | [**get_component_runs**](docs/ComponentRunApi.md#get_component_runs) | **GET** /component_runs | GetComponentRuns list.
*ComponentRunApi* | [**terminate_component_run**](docs/ComponentRunApi.md#terminate_component_run) | **POST** /component_runs/{id}/terminate | 
*ComponentRunApi* | [**update_component_run**](docs/ComponentRunApi.md#update_component_run) | **PUT** /component_runs/{id} | UpdateComponentRun by id.
*DeploymentApi* | [**create_deployment**](docs/DeploymentApi.md#create_deployment) | **POST** /deployments | CreateDeployment.
*DeploymentApi* | [**delete_deployment**](docs/DeploymentApi.md#delete_deployment) | **DELETE** /deployments/{id} | DeleteDeployment by id.
*DeploymentApi* | [**get_deployment_by_id**](docs/DeploymentApi.md#get_deployment_by_id) | **GET** /deployments/{id} | GetDeployment by id.
*DeploymentApi* | [**get_deployments**](docs/DeploymentApi.md#get_deployments) | **GET** /deployments | GetDeployments list.
*DeploymentApi* | [**pause_deployment**](docs/DeploymentApi.md#pause_deployment) | **POST** /deployments/{id}/pause | PauseDeployment by id.
*DeploymentApi* | [**resume_deployment**](docs/DeploymentApi.md#resume_deployment) | **POST** /deployments/{id}/resume | ResumeDeployment by id.
*ExecutionEventApi* | [**create_execution_event**](docs/ExecutionEventApi.md#create_execution_event) | **POST** /execution_events | CreateExecutionEvent.
*ExecutionEventApi* | [**delete_execution_event**](docs/ExecutionEventApi.md#delete_execution_event) | **DELETE** /execution_events/{id} | DeleteExecutionEvent by id.
*ExecutionEventApi* | [**get_execution_event_by_id**](docs/ExecutionEventApi.md#get_execution_event_by_id) | **GET** /execution_events/{id} | GetExecutionEvent by id.
*ExecutionEventApi* | [**get_execution_events**](docs/ExecutionEventApi.md#get_execution_events) | **GET** /execution_events | GetExecutionEvents list.
*ExperimentApi* | [**activate_experiment**](docs/ExperimentApi.md#activate_experiment) | **POST** /experiments/{id}/activate | ActivateExperiment by id.
*ExperimentApi* | [**archive_experiment**](docs/ExperimentApi.md#archive_experiment) | **POST** /experiments/{id}/archive | ArchiveExperiment by id.
*ExperimentApi* | [**create_experiment**](docs/ExperimentApi.md#create_experiment) | **POST** /experiments | CreateExperiment.
*ExperimentApi* | [**deactivate_experiment**](docs/ExperimentApi.md#deactivate_experiment) | **POST** /experiments/{id}/deactivate | DeactivateExperiment by id.
*ExperimentApi* | [**delete_experiment**](docs/ExperimentApi.md#delete_experiment) | **DELETE** /experiments/{id} | DeleteExperiment by id.
*ExperimentApi* | [**get_experiment_by_id**](docs/ExperimentApi.md#get_experiment_by_id) | **GET** /experiments/{id} | GetExperiment by id.
*ExperimentApi* | [**get_experiments**](docs/ExperimentApi.md#get_experiments) | **GET** /experiments | GetExperiments list.
*ExperimentApi* | [**trigger_experiment_run**](docs/ExperimentApi.md#trigger_experiment_run) | **POST** /experiments/{id}/trigger_run | TriggerExperimentRun.
*ExperimentApi* | [**update_experiment**](docs/ExperimentApi.md#update_experiment) | **PUT** /experiments/{id} | UpdateExperiment by id.
*ExperimentRunApi* | [**create_experiment_run**](docs/ExperimentRunApi.md#create_experiment_run) | **POST** /experiment_runs | CreateExperimentRun.
*ExperimentRunApi* | [**delete_experiment_run**](docs/ExperimentRunApi.md#delete_experiment_run) | **DELETE** /experiment_runs/{id} | DeleteExperimentRun by id.
*ExperimentRunApi* | [**get_experiment_run_by_id**](docs/ExperimentRunApi.md#get_experiment_run_by_id) | **GET** /experiment_runs/{id} | GetExperimentRun by id.
*ExperimentRunApi* | [**get_experiment_runs**](docs/ExperimentRunApi.md#get_experiment_runs) | **GET** /experiment_runs | GetExperimentRuns list.
*ExperimentRunApi* | [**retry_experiment_run**](docs/ExperimentRunApi.md#retry_experiment_run) | **POST** /experiment_runs/{id}/retry | RetryExperimentRun.
*ExperimentRunApi* | [**terminate_experiment_run**](docs/ExperimentRunApi.md#terminate_experiment_run) | **POST** /experiment_runs/{id}/terminate | TerminateExperimentRun.
*ExperimentRunApi* | [**update_experiment_run**](docs/ExperimentRunApi.md#update_experiment_run) | **PUT** /experiment_runs/{id} | UpdateExperimentRun by id.
*ExperimentVersionApi* | [**activate_experiment_version**](docs/ExperimentVersionApi.md#activate_experiment_version) | **POST** /experiment_version/{exp_id}/{id}/activate | ActivateExperimentVersion by id.
*ExperimentVersionApi* | [**archive_experiment_version**](docs/ExperimentVersionApi.md#archive_experiment_version) | **POST** /experiment_version/{exp_id}/{id}/archive | ArchiveExperimentVersion by id.
*ExperimentVersionApi* | [**create_experiment_version**](docs/ExperimentVersionApi.md#create_experiment_version) | **POST** /experiment_version | CreateExperimentVersion.
*ExperimentVersionApi* | [**delete_experiment_version**](docs/ExperimentVersionApi.md#delete_experiment_version) | **DELETE** /experiment_version/{exp_id}/{id} | DeleteExperimentVersion by id.
*ExperimentVersionApi* | [**get_experiment_version_by_id**](docs/ExperimentVersionApi.md#get_experiment_version_by_id) | **GET** /experiment_version/{exp_id}/{id} | GetExperimentVersion by id.
*ExperimentVersionApi* | [**get_experiment_versions**](docs/ExperimentVersionApi.md#get_experiment_versions) | **GET** /experiment_version/{exp_id} | GetExperimentVersions list.
*ExperimentVersionApi* | [**pause_experiment_version**](docs/ExperimentVersionApi.md#pause_experiment_version) | **POST** /experiment_version/{exp_id}/{id}/pause | PauseExperimentVersion by id.
*ExperimentVersionApi* | [**trigger_experiment_version_run**](docs/ExperimentVersionApi.md#trigger_experiment_version_run) | **POST** /experiment_version/{exp_id}/{id}/trigger_run | TriggerExperimentVersionRun.
*GroupApi* | [**create_group**](docs/GroupApi.md#create_group) | **POST** /groups | CreateGroup.
*GroupApi* | [**delete_group**](docs/GroupApi.md#delete_group) | **DELETE** /groups/{id} | DeleteGroup by id.
*GroupApi* | [**get_group_by_id**](docs/GroupApi.md#get_group_by_id) | **GET** /groups/{id} | GetGroup by id.
*GroupApi* | [**get_groups**](docs/GroupApi.md#get_groups) | **GET** /groups | GetGroups list.
*GroupApi* | [**update_group**](docs/GroupApi.md#update_group) | **PUT** /groups/{id} | UpdateGroup by id.
*ModelApi* | [**create_model**](docs/ModelApi.md#create_model) | **POST** /models | CreateModel.
*ModelApi* | [**delete_model**](docs/ModelApi.md#delete_model) | **DELETE** /models/{id} | DeleteModel by id.
*ModelApi* | [**get_model_by_id**](docs/ModelApi.md#get_model_by_id) | **GET** /models/{id} | GetModel by id.
*ModelApi* | [**get_models**](docs/ModelApi.md#get_models) | **GET** /models | GetModels list.
*ModelApi* | [**update_model**](docs/ModelApi.md#update_model) | **PUT** /models/{id} | UpdateModel by id.
*ModelSuiteApi* | [**create_model_suite**](docs/ModelSuiteApi.md#create_model_suite) | **POST** /model_suites | CreateModelSuite.
*ModelSuiteApi* | [**delete_model_suite**](docs/ModelSuiteApi.md#delete_model_suite) | **DELETE** /model_suites/{id} | DeleteModelSuite by id.
*ModelSuiteApi* | [**get_model_suite_by_id**](docs/ModelSuiteApi.md#get_model_suite_by_id) | **GET** /model_suites/{id} | GetModelSuite by id.
*ModelSuiteApi* | [**get_model_suites**](docs/ModelSuiteApi.md#get_model_suites) | **GET** /model_suites | GetModelSuites list.
*ModelSuiteApi* | [**update_model_suite**](docs/ModelSuiteApi.md#update_model_suite) | **PUT** /model_suites/{id} | UpdateModelSuite by id.
*PipelineApi* | [**create_pipeline**](docs/PipelineApi.md#create_pipeline) | **POST** /pipelines | CreatePipeline.
*PipelineApi* | [**delete_pipeline**](docs/PipelineApi.md#delete_pipeline) | **DELETE** /pipelines/{id} | DeletePipeline by id.
*PipelineApi* | [**get_pipeline_by_id**](docs/PipelineApi.md#get_pipeline_by_id) | **GET** /pipelines/{id} | GetPipeline by id.
*PipelineApi* | [**get_pipelines**](docs/PipelineApi.md#get_pipelines) | **GET** /pipelines | GetPipelines list.
*PipelineApi* | [**update_pipeline**](docs/PipelineApi.md#update_pipeline) | **PUT** /pipelines/{id} | UpdatePipeline by id.
*PipelineVersionApi* | [**create_pipeline_version**](docs/PipelineVersionApi.md#create_pipeline_version) | **POST** /pipeline_versions | CreatePipelineVersion.
*PipelineVersionApi* | [**delete_pipeline_version**](docs/PipelineVersionApi.md#delete_pipeline_version) | **DELETE** /pipeline_versions/{id} | DeletePipelineVersion by id.
*PipelineVersionApi* | [**get_pipeline_version_by_id**](docs/PipelineVersionApi.md#get_pipeline_version_by_id) | **GET** /pipeline_versions/{id} | GetPipelineVersion by id.
*PipelineVersionApi* | [**get_pipeline_versions**](docs/PipelineVersionApi.md#get_pipeline_versions) | **GET** /pipeline_versions | GetPipelineVersions list.
*PipelineVersionApi* | [**update_pipeline_version**](docs/PipelineVersionApi.md#update_pipeline_version) | **PUT** /pipeline_versions/{id} | UpdatePipelineVersion by id.
*UserApi* | [**create_user**](docs/UserApi.md#create_user) | **POST** /users | CreateUser.
*UserApi* | [**delete_user**](docs/UserApi.md#delete_user) | **DELETE** /users/{id} | DeleteUser by id.
*UserApi* | [**get_my_info**](docs/UserApi.md#get_my_info) | **GET** /myinfo | 
*UserApi* | [**get_user_by_id**](docs/UserApi.md#get_user_by_id) | **GET** /users/{id} | GetUser by id.
*UserApi* | [**get_users**](docs/UserApi.md#get_users) | **GET** /users | GetUsers list.
*UserApi* | [**update_user**](docs/UserApi.md#update_user) | **PUT** /users/{id} | UpdateUser by id.


## Documentation For Models

 - [Artifact](docs/Artifact.md)
 - [ComponentRun](docs/ComponentRun.md)
 - [Deployment](docs/Deployment.md)
 - [ErrorResponse](docs/ErrorResponse.md)
 - [ExecutionEvent](docs/ExecutionEvent.md)
 - [Experiment](docs/Experiment.md)
 - [ExperimentRun](docs/ExperimentRun.md)
 - [ExperimentRunSummary](docs/ExperimentRunSummary.md)
 - [ExperimentVersion](docs/ExperimentVersion.md)
 - [GetArtifactsResponse](docs/GetArtifactsResponse.md)
 - [GetComponentRunsResponse](docs/GetComponentRunsResponse.md)
 - [GetDeploymentsResponse](docs/GetDeploymentsResponse.md)
 - [GetExecutionEventsResponse](docs/GetExecutionEventsResponse.md)
 - [GetExperimentRunsResponse](docs/GetExperimentRunsResponse.md)
 - [GetExperimentsResponse](docs/GetExperimentsResponse.md)
 - [GetGroupsResponse](docs/GetGroupsResponse.md)
 - [GetModelSuitesResponse](docs/GetModelSuitesResponse.md)
 - [GetModelsResponse](docs/GetModelsResponse.md)
 - [GetPipelineVersionsResponse](docs/GetPipelineVersionsResponse.md)
 - [GetPipelinesResponse](docs/GetPipelinesResponse.md)
 - [GetUsersResponse](docs/GetUsersResponse.md)
 - [GetVersionsResponse](docs/GetVersionsResponse.md)
 - [Group](docs/Group.md)
 - [Model](docs/Model.md)
 - [ModelSuite](docs/ModelSuite.md)
 - [Node](docs/Node.md)
 - [NodeIO](docs/NodeIO.md)
 - [ParameterConfig](docs/ParameterConfig.md)
 - [ParameterValidator](docs/ParameterValidator.md)
 - [Pipeline](docs/Pipeline.md)
 - [PipelineVersion](docs/PipelineVersion.md)
 - [RunContext](docs/RunContext.md)
 - [TriggerExperimentRequest](docs/TriggerExperimentRequest.md)
 - [TriggerVersionRequest](docs/TriggerVersionRequest.md)
 - [User](docs/User.md)


## Documentation For Authorization


## basicAuth

- **Type**: HTTP basic authentication


## Author




